<?php
  error_reporting(E_ALL);
  ob_implicit_flush(true);

  asterisk_exec('Ringing', '');
  sleep(1);
  asterisk_answer();
  asterisk_setwhentohangup(-1);

/*
  print_r(get_defined_constants());

  echo "\n";
  print_r($_SERVER);
  echo "\n\n";
*/

  define('NORMAL', 0);
  define('SKIP', 1);
  define('SHOULD_ERROR', 2);

  function test($function, $args, $run=NORMAL)
  {
    $ret = '';
    $cmd = "\$ret = $function(" . join(', ', $args) . ');';
    echo "\n**************************************************\n$cmd\n";
    if($run != SKIP)
    {
      if($run == SHOULD_ERROR) echo "SHOULD ERROR!\n";
      eval($cmd);
    }
    else
    {
      $ret = 'failed (skipped)';
    }
    echo "ret = " . print_r($ret, true) . "\n**************************************************\n";
    @ob_flush();
  }


  define('INTS', "'123#'");
  define('LANG', "'es'");
  define('TIMEOUT', 2);
  define('MAXDIGITS', 1);
//  define('STREAM_FILE', "'tt-monkeys'");
  define('STREAM_FILE', "'digits/2'");
  define('STREAM_OFFSET', 1000);
  define('STREAM_FWD', "'6'");
  define('STREAM_REV', "'4'");
  define('STREAM_STOP', "'8'");
  define('STREAM_PAUSE', "'5'");
  define('FORMAT_NAME', "'ulaw'");
  define('FORMAT_NUMBER', 4);
  define('VARIABLE_NAME', "'SOMEVAR'");
  define('VARIABLE_VALUE', "'SOMEVALUE'");
  define('TDD_MODE', "'TDD_MODE'");
  define('MOH_CLASS', "'MOH_CLASS'");
  define('APP', "'SayNumber'");
  define('APP_DATA', "'123'");
  define('EXTRA_PARAMETER', "'EXTRA_PARAMTER'");

  // guess at channel and peer
  list($channel, $peer) = asterisk_chanlist();
  define('CHANNEL', "'{$channel['channel']}'");
  define('PEER', "'{$peer['channel']}'");


  test('asterisk_answer', array());
  test('asterisk_answer', array(EXTRA_PARAMETER), SHOULD_ERROR);
  test('asterisk_answer', array(CHANNEL));
  test('asterisk_answer', array(CHANNEL, EXTRA_PARAMETER), SHOULD_ERROR);

  test('asterisk_best_codec', array());
  test('asterisk_best_codec', array(EXTRA_PARAMETER), SHOULD_ERROR);
  test('asterisk_best_codec', array(CHANNEL, EXTRA_PARAMETER), SHOULD_ERROR);

  test('asterisk_bridge_call', array(), SHOULD_ERROR);
  test('asterisk_bridge_call', array(PEER), SKIP);
  test('asterisk_bridge_call', array(PEER, 'OPTIONS'), SKIP);
  test('asterisk_bridge_call', array(CHANNEL, PEER, 'OPTIONS'), SKIP);
  test('asterisk_bridge_call', array(CHANNEL, PEER, 'OPTIONS', EXTRA_PARAMETER), SHOULD_ERROR);

  test('asterisk_chanlist', array());
  test('asterisk_chanlist', array(EXTRA_PARAMETER), SHOULD_ERROR);

  test('asterisk_channel_make_compatible', array(), SHOULD_ERROR);
  test('asterisk_channel_make_compatible', array(PEER), SKIP);
  test('asterisk_channel_make_compatible', array(CHANNEL, PEER), SKIP);
  test('asterisk_channel_make_compatible', array(CHANNEL, PEER, EXTRA_PARAMETER), SHOULD_ERROR);

  test('asterisk_channel_setoption', array('OPTION', 'DATA'), SKIP);
  test('asterisk_channel_setoption', array(CHANNEL, 'OPTION', 'DATA'), SKIP);

  test('asterisk_channel_status', array());
  test('asterisk_channel_status', array(EXTRA_PARAMETER), SHOULD_ERROR);
  test('asterisk_channel_status', array(CHANNEL));
  test('asterisk_channel_status', array(CHANNEL, EXTRA_PARAMETER), SHOULD_ERROR);

  test('asterisk_cli', array('FD', 'CMD'), SKIP);

  test('asterisk_codec2str', array('asterisk_best_codec()'));
  test('asterisk_codec2str', array(-1));

  test('asterisk_control_streamfile', array(), SHOULD_ERROR);
  test('asterisk_control_streamfile', array(STREAM_FILE), SHOULD_ERROR);
  test('asterisk_control_streamfile', array(STREAM_FILE, STREAM_FWD), SHOULD_ERROR);
  test('asterisk_control_streamfile', array(STREAM_FILE, STREAM_FWD, STREAM_REV), SHOULD_ERROR);
  test('asterisk_control_streamfile', array(STREAM_FILE, STREAM_FWD, STREAM_REV, STREAM_STOP), SHOULD_ERROR);
  test('asterisk_control_streamfile', array(STREAM_FILE, STREAM_FWD, STREAM_REV, STREAM_STOP, STREAM_PAUSE));
  test('asterisk_control_streamfile', array(STREAM_FILE, STREAM_FWD, STREAM_REV, STREAM_STOP, STREAM_PAUSE, STREAM_OFFSET));
  test('asterisk_control_streamfile', array(CHANNEL, STREAM_FILE, STREAM_FWD, STREAM_REV, STREAM_STOP, STREAM_PAUSE, STREAM_OFFSET));
  test('asterisk_control_streamfile', array(CHANNEL, STREAM_FILE, STREAM_FWD, STREAM_REV, STREAM_STOP, STREAM_PAUSE, STREAM_OFFSET, EXTRA_PARAMETER), SHOULD_ERROR);

  test('asterisk_db_del', array(), SHOULD_ERROR);
  test('asterisk_db_del', array('FAMILY'), SHOULD_ERROR);
  test('asterisk_db_del', array('FAMILY', 'KEYS'), SKIP);
  test('asterisk_db_del', array('FAMILY', 'KEYS', EXTRA_PARAMETER), SHOULD_ERROR);

  test('asterisk_db_deltree', array(), SHOULD_ERROR);
  test('asterisk_db_deltree', array('FAMILY'), SKIP);
  test('asterisk_db_deltree', array('FAMILY', 'KEYTREE'), SKIP);
  test('asterisk_db_deltree', array('FAMILY', 'KEYTREE', EXTRA_PARAMETER), SHOULD_ERROR);

  test('asterisk_db_get', array(), SHOULD_ERROR);
  test('asterisk_db_get', array('FAMILY'), SHOULD_ERROR);
  test('asterisk_db_get', array('FAMILY', 'KEYS'), SKIP);
  test('asterisk_db_get', array('FAMILY', 'KEYS', EXTRA_PARAMETER), SHOULD_ERROR);

  test('asterisk_db_put', array(), SHOULD_ERROR);
  test('asterisk_db_put', array('FAMILY'), SHOULD_ERROR);
  test('asterisk_db_put', array('FAMILY', 'KEYS'), SHOULD_ERROR);
  test('asterisk_db_put', array('FAMILY', 'KEYS', 'VALUE'), SKIP);
  test('asterisk_db_put', array('FAMILY', 'KEYS', 'VALUE', EXTRA_PARAMETER), SHOULD_ERROR);

  test('asterisk_exec', array(), SHOULD_ERROR);
  test('asterisk_exec', array(APP));
  test('asterisk_exec', array(APP, APP_DATA));
  test('asterisk_exec', array(CHANNEL, APP, APP_DATA));
  test('asterisk_exec', array(CHANNEL, APP, APP_DATA, EXTRA_PARAMETER), SHOULD_ERROR);

  test('asterisk_getdata', array(), SHOULD_ERROR);
  test('asterisk_getdata', array(STREAM_FILE));
  test('asterisk_getdata', array(STREAM_FILE, MAXDIGITS));
  test('asterisk_getdata', array(STREAM_FILE, MAXDIGITS, TIMEOUT));
  test('asterisk_getdata', array(CHANNEL, STREAM_FILE, MAXDIGITS, TIMEOUT));
  test('asterisk_getdata', array(CHANNEL, STREAM_FILE, MAXDIGITS, TIMEOUT, EXTRA_PARAMETER), SHOULD_ERROR);

  test('asterisk_getformatbyname', array(), SHOULD_ERROR);
  test('asterisk_getformatbyname', array(FORMAT_NAME));
  test('asterisk_getformatbyname', array(FORMAT_NAME, EXTRA_PARAMETER), SHOULD_ERROR);

  test('asterisk_getformatname', array(), SHOULD_ERROR);
  test('asterisk_getformatname', array(FORMAT_NUMBER));
  test('asterisk_getformatname', array(FORMAT_NUMBER, EXTRA_PARAMETER), SHOULD_ERROR);

  test('asterisk_get_priority', array());
  test('asterisk_get_priority', array(CHANNEL));
  test('asterisk_get_priority', array(CHANNEL, EXTRA_PARAMETER), SHOULD_ERROR);

  test('asterisk_set_variable', array(), SHOULD_ERROR);
  test('asterisk_set_variable', array(VARIABLE_NAME), SHOULD_ERROR);
  test('asterisk_set_variable', array(VARIABLE_NAME, VARIABLE_VALUE));
  test('asterisk_set_variable', array(CHANNEL, VARIABLE_NAME, VARIABLE_VALUE));
  test('asterisk_set_variable', array(CHANNEL, VARIABLE_NAME, VARIABLE_VALUE, EXTRA_PARAMETER), SHOULD_ERROR);

  test('asterisk_get_variable', array(), SHOULD_ERROR);
  test('asterisk_get_variable', array(CHANNEL, VARIABLE_NAME));
  test('asterisk_get_variable', array(CHANNEL, VARIABLE_NAME, EXTRA_PARAMETER), SHOULD_ERROR);

  test('asterisk_get_variables', array());
  test('asterisk_get_variables', array(CHANNEL));
  test('asterisk_get_variables', array(CHANNEL, EXTRA_PARAMETER), SHOULD_ERROR);

  test('asterisk_log', array(), SHOULD_ERROR);
  test('asterisk_log', array('LOG'), SHOULD_ERROR);
  test('asterisk_log', array('LOG', 'MESSAGE'), SKIP);
  test('asterisk_log', array('LOG', 'MESSAGE', EXTRA_PARAMETER), SHOULD_ERROR);

  test('asterisk_manager_command', array('FD', 'CMD'), SKIP);

  test('asterisk_moh_start', array(), SKIP);
  test('asterisk_moh_start', array(MOH_CLASS), SKIP);
  test('asterisk_moh_start', array(CHANNEL, MOH_CLASS), SKIP);
  test('asterisk_moh_start', array(CHANNEL, MOH_CLASS, EXTRA_PARAMETER), SHOULD_ERROR);

  test('asterisk_moh_stop', array(), SKIP);
  test('asterisk_moh_stop', array(CHANNEL), SKIP);
  test('asterisk_moh_stop', array(CHANNEL, EXTRA_PARAMETER), SHOULD_ERROR);

  test('asterisk_recvchar', array(), SHOULD_ERROR);
  test('asterisk_recvchar', array(TIMEOUT), SKIP);
  test('asterisk_recvchar', array(CHANNEL, TIMEOUT), SKIP);
  test('asterisk_recvchar', array(CHANNEL, TIMEOUT, EXTRA_PARAMETER), SHOULD_ERROR);

  test('asterisk_request', array('TYPE', 'FORMAT', 'DATA', '&CAUSE'), SKIP);

  test('asterisk_request_and_dial', array('TYPE', 'FORMAT', 'DATA', TIMEOUT, 'OUTSTATE', 'CALLERID'), SKIP);

  test('asterisk_say_character_str', array(), SHOULD_ERROR);
  test('asterisk_say_character_str', array("'HELLO'"));
  test('asterisk_say_character_str', array("'HELLO'", INTS));
  test('asterisk_say_character_str', array("'HELLO'", INTS, LANG));
  test('asterisk_say_character_str', array(CHANNEL, "'HELLO'", INTS, LANG));
  test('asterisk_say_character_str', array(CHANNEL, "'HELLO'", INTS, LANG, EXTRA_PARAMETER), SHOULD_ERROR);

  test('asterisk_say_date', array());
  test('asterisk_say_date', array(time()-3600));
  test('asterisk_say_date', array(time()-3600, INTS));
  test('asterisk_say_date', array(time()-3600, INTS, LANG));
  test('asterisk_say_date', array(time()-3600, INTS, LANG, 'FORMAT'), SKIP);
  test('asterisk_say_date', array(time()-3600, INTS, LANG, 'FORMAT', 'TIMEZONE'), SKIP);
  test('asterisk_say_date', array(CHANNEL, time()-3600, INTS, LANG, 'FORMAT', 'TIMEZONE'), SKIP);
  test('asterisk_say_date', array(CHANNEL, time()-3600, INTS, LANG, 'FORMAT', 'TIMEZONE', EXTRA_PARAMETER), SHOULD_ERROR);

  test('asterisk_say_datetime', array());
  test('asterisk_say_datetime', array(time()-3600));
  test('asterisk_say_datetime', array(time()-3600, INTS));
  test('asterisk_say_datetime', array(time()-3600, INTS, LANG));
  test('asterisk_say_datetime', array(CHANNEL, time()-3600, INTS, LANG));
  test('asterisk_say_datetime', array(CHANNEL, time()-3600, INTS, LANG, EXTRA_PARAMETER), SHOULD_ERROR);

  test('asterisk_say_datetime_from_now', array());
  test('asterisk_say_datetime_from_now', array(-3600));
  test('asterisk_say_datetime_from_now', array(-3600, INTS));
  test('asterisk_say_datetime_from_now', array(-3600, INTS, LANG));
  test('asterisk_say_datetime_from_now', array(CHANNEL, -3600, INTS, LANG));
  test('asterisk_say_datetime_from_now', array(CHANNEL, -3600, INTS, LANG, EXTRA_PARAMETER), SHOULD_ERROR);

  test('asterisk_say_digit_str', array(), SHOULD_ERROR);
  test('asterisk_say_digit_str', array("'1234'"));
  test('asterisk_say_digit_str', array("'1234'", INTS));
  test('asterisk_say_digit_str', array("'1234'", INTS, LANG));
  test('asterisk_say_digit_str', array(CHANNEL, "'1234'", INTS, LANG));
  test('asterisk_say_digit_str', array(CHANNEL, "'1234'", INTS, LANG, EXTRA_PARAMETER), SHOULD_ERROR);

  test('asterisk_say_number', array(), SHOULD_ERROR);
  test('asterisk_say_number', array(12345));
  test('asterisk_say_number', array(12345, INTS));
  test('asterisk_say_number', array(12345, INTS, LANG));
  test('asterisk_say_number', array(12345, INTS, LANG, 'OPTIONS'), SKIP);
  test('asterisk_say_number', array(CHANNEL, 12345, INTS, LANG, 'OPTIONS'), SKIP);
  test('asterisk_say_number', array(CHANNEL, 12345, INTS, LANG, 'OPTIONS', EXTRA_PARAMETER), SHOULD_ERROR);

  test('asterisk_say_phonetic_str', array(), SHOULD_ERROR);
  test('asterisk_say_phonetic_str', array("'HELLO'"));
  test('asterisk_say_phonetic_str', array("'HELLO'", INTS));
  test('asterisk_say_phonetic_str', array("'HELLO'", INTS, LANG));
  test('asterisk_say_phonetic_str', array(CHANNEL, "'HELLO'", INTS, LANG));
  test('asterisk_say_phonetic_str', array(CHANNEL, "'HELLO'", INTS, LANG, EXTRA_PARAMETER), SHOULD_ERROR);

  test('asterisk_say_time', array());
  test('asterisk_say_time', array(time()-3600));
  test('asterisk_say_time', array(time()-3600, INTS));
  test('asterisk_say_time', array(time()-3600, INTS, LANG));
  test('asterisk_say_time', array(CHANNEL, time()-3600, INTS, LANG));
  test('asterisk_say_time', array(CHANNEL, time()-3600, INTS, LANG, EXTRA_PARAMETER), SHOULD_ERROR);

  test('asterisk_senddigit', array(), SHOULD_ERROR);
  test('asterisk_senddigit', array('DIGITS'), SKIP);
  test('asterisk_senddigit', array(CHANNEL, 'DIGITS'), SKIP);
  test('asterisk_senddigit', array(CHANNEL, 'DIGITS', EXTRA_PARAMETER), SHOULD_ERROR);

  test('asterisk_send_image', array(), SHOULD_ERROR);
  test('asterisk_send_image', array(CHANNEL, 'IMAGE'), SKIP);
  test('asterisk_send_image', array(CHANNEL, 'IMAGE', EXTRA_PARAMETER), SHOULD_ERROR);

  test('asterisk_sendtext', array(), SHOULD_ERROR);
  test('asterisk_sendtext', array('TEXT'), SKIP);
  test('asterisk_sendtext', array(CHANNEL, 'TEXT', EXTRA_PARAMETER), SHOULD_ERROR);

  test('asterisk_set_best_read_format', array());
  test('asterisk_set_best_read_format', array(CHANNEL));
  test('asterisk_set_best_read_format', array(CHANNEL, EXTRA_PARAMETER), SHOULD_ERROR);

  test('asterisk_set_best_write_format', array());
  test('asterisk_set_best_write_format', array(CHANNEL));
  test('asterisk_set_best_write_format', array(CHANNEL, EXTRA_PARAMETER), SHOULD_ERROR);

  test('asterisk_set_callerid', array(), SHOULD_ERROR);
  test('asterisk_set_callerid', array('CALLERID'), SKIP);
  test('asterisk_set_callerid', array('CALLERID', 'ANITOO'), SKIP);
  test('asterisk_set_callerid', array(CHANNEL, 'CALLERID', 'ANITOO'), SKIP);
  test('asterisk_set_callerid', array(CHANNEL, 'CALLERID', 'ANITOO', EXTRA_PARAMETER), SHOULD_ERROR);

  test('asterisk_set_context', array(), SHOULD_ERROR);
  test('asterisk_set_context', array('CONTEXT'), SKIP);
  test('asterisk_set_context', array(CHANNEL, 'CONTEXT'), SKIP);
  test('asterisk_set_context', array(CHANNEL, 'CONTEXT', EXTRA_PARAMETER), SHOULD_ERROR);

  test('asterisk_set_extension', array(), SHOULD_ERROR);
  test('asterisk_set_extension', array('EXTEN'), SKIP);
  test('asterisk_set_extension', array(CHANNEL, 'EXTEN'), SKIP);
  test('asterisk_set_extension', array(CHANNEL, 'EXTEN', EXTRA_PARAMETER), SHOULD_ERROR);

  test('asterisk_set_priority', array(), SHOULD_ERROR);
  test('asterisk_set_priority', array('PRIORITY'), SKIP);
  test('asterisk_set_priority', array(CHANNEL, 'PRIORITY'), SKIP);
  test('asterisk_set_priority', array(CHANNEL, 'PRIORITY', EXTRA_PARAMETER), SHOULD_ERROR);

  test('asterisk_set_read_format', array(), SHOULD_ERROR);
  test('asterisk_set_read_format', array('FORMAT'), SKIP);
  test('asterisk_set_read_format', array(CHANNEL, 'FORMAT'), SKIP);
  test('asterisk_set_read_format', array(CHANNEL, 'FORMAT', EXTRA_PARAMETER), SHOULD_ERROR);

  test('asterisk_setwhentohangup', array(), SHOULD_ERROR);
  test('asterisk_setwhentohangup', array(TIMEOUT), SKIP);
  test('asterisk_setwhentohangup', array(CHANNEL, TIMEOUT), SKIP);
  test('asterisk_setwhentohangup', array(CHANNEL, TIMEOUT, EXTRA_PARAMETER), SHOULD_ERROR);

  test('asterisk_set_write_format', array(), SHOULD_ERROR);
  test('asterisk_set_write_format', array('FORMAT'), SKIP);
  test('asterisk_set_write_format', array(CHANNEL, 'FORMAT'), SKIP);
  test('asterisk_set_write_format', array(CHANNEL, 'FORMAT', EXTRA_PARAMETER), SHOULD_ERROR);

  test('asterisk_state2str', array(), SHOULD_ERROR);
  test('asterisk_state2str', array('asterisk_channel_status()'), SKIP);
  test('asterisk_state2str', array('asterisk_channel_status()', EXTRA_PARAMETER), SHOULD_ERROR);

  test('asterisk_stream_file', array(), SHOULD_ERROR);
  test('asterisk_stream_file', array(STREAM_FILE));
  test('asterisk_stream_file', array(STREAM_FILE, INTS), SKIP);
  test('asterisk_stream_file', array(STREAM_FILE, INTS, STREAM_OFFSET), SKIP);
  test('asterisk_stream_file', array(STREAM_FILE, INTS, STREAM_OFFSET, LANG), SKIP);
  test('asterisk_stream_file', array(CHANNEL, STREAM_FILE, INTS, STREAM_OFFSET, LANG), SKIP);
  test('asterisk_stream_file', array(CHANNEL, STREAM_FILE, INTS, STREAM_OFFSET, LANG, EXTRA_PARAMETER), SHOULD_ERROR);

  test('asterisk_tdd_mode', array(), SHOULD_ERROR);
  test('asterisk_tdd_mode', array(TDD_MODE), SKIP);
  test('asterisk_tdd_mode', array(CHANNEL, TDD_MODE), SKIP);
  test('asterisk_tdd_mode', array(CHANNEL, TDD_MODE, EXTRA_PARAMETER), SHOULD_ERROR);

  test('asterisk_verbose', array(), SHOULD_ERROR);
  test('asterisk_verbose', array(4), SHOULD_ERROR);
  test('asterisk_verbose', array(4, 'MESSAGE'));
  test('asterisk_verbose', array(4, 'MESSAGE', EXTRA_PARAMETER), SHOULD_ERROR);

  test('asterisk_waitfor', array(), SHOULD_ERROR);
  test('asterisk_waitfor', array('WAIT'), SKIP);
  test('asterisk_waitfor', array(CHANNEL, 'WAIT'), SKIP);
  test('asterisk_waitfor', array(CHANNEL, 'WAIT', EXTRA_PARAMETER), SHOULD_ERROR);

  test('asterisk_waitfordigit', array());
  test('asterisk_waitfordigit', array(TIMEOUT), SKIP);
  test('asterisk_waitfordigit', array(CHANNEL, TIMEOUT), SKIP);
  test('asterisk_waitfordigit', array(CHANNEL, TIMEOUT, EXTRA_PARAMETER), SHOULD_ERROR);

  test('asterisk_this_function_does_not_exist', array(), SHOULD_ERROR);

  test('asterisk_hangup', array());
  test('asterisk_hangup', array('CAUSE'), SKIP);
  test('asterisk_hangup', array(CHANNEL, 'CAUSE'), SKIP);
  test('asterisk_hangup', array(CHANNEL, 'CAUSE', EXTRA_PARAMETER), SHOULD_ERROR);


?>
